/* header file for obsmcs.c
 */
void rt_com_exit( void );
void rt_com_init( void );
int  rt_com_read( int, char *, int );
void rt_com_setup( unsigned, unsigned, unsigned, unsigned );
void rt_com_write( int, char *, int );

/*-----------------------------------------------------------------------*/
#define TRIGGER 4
#define FIFO 4

/*-----------------------------------------------------------------------*/
/* status masks, several bits may be set simultaneously     */
/* status information is returned by LineStatus and as      */
/* the high byte of COMData                                 */

#define DATA_READY   0x01     /* not an error               */
#define OVERRUN      0x02     /* error detected by hardware */
#define PARITY       0x04     /* error detected by hardware */
#define FRAME        0x08     /* error detected by hardware */
#define BREAK        0x10     /* not an error               */
#define BUFFER_FULL  0x80     /* error detected by software */
#define TXB_EMPTY    0x20     /* not an error               */
#define HARD_ERROR   (OVERRUN | PARITY | FRAME | BREAK)

/* port offsets */
#define RXB  0x00 /* Receive register  (READ)  */
#define TXB  0x00 /* Transmit register (WRITE) */
#define IER  0x01 /* Interrupt Enable          */
#define IIR  0x02 /* Interrupt ID              */
#define FCR  0x02 
#define LCR  0x03 /* Line control              */
#define MCR  0x04 /* Modem control             */
#define LSR  0x05 /* Line Status               */
#define MSR  0x06 /* Modem Status              */
#define DLL  0x00 /* Divisor Latch Low         */
#define DLM  0x01 /* Divisor Latch High        */

#define PARITY_EVEN  0        /* for port initialisation    */
#define PARITY_ODD   1
#define PARITY_NONE  2

/* bit masks which may be written to the MCR using ModemControl */
#define DTR          0x01     /* data Terminal Ready        */
#define RTS          0x02     /* Request To Send            */
#define Out1         0x04
#define Out2         0x08
#define LoopBack     0x10

#define RT_BUF_SIZ 64

struct rt_buf_struct{
  int  head;
  int  tail;
  char buf[ RT_BUF_SIZ ];
};

struct rt_com_struct{
  int magic;
  int baud_base;
  int port;
  int irq;
  int flag;
  void (*isr)(void);
  int type;
  
  int ier;  /* copy of chip register */

  struct rt_buf_struct ibuf;
  struct rt_buf_struct obuf;
};

struct rt_trans_buf{
  char odat[512];
  int ion;
  int iox;
};

/*-----------------------------------------------------------------------*/

#define BASE_BAUD 115200
#define STD_COM_FLAG 0
#define RT_COM_CNT 3
